from GRANTA_MIScriptingToolkit import granta as mpy


# sort based on attribute 'Base'
attribute = 'Base'

# records with base 'Oxide' go in the 'Oxides' subset and
# 'Fe (Iron)' go in the 'Iron-based' subset
base_to_subset = {'Oxide': 'Oxides', 'Fe (Iron)': 'Iron-based'}
s = mpy.connect('localhost/mi_servicelayer', autologon=True)
tab = s.get_db('MI:Training').get_table('MaterialUniverse')

# generics included and folders excluded by default
recs = tab.all_records()
tab.bulk_fetch(recs, attributes=[attribute])

changed_recs = []
for r in recs:
    base = r.attributes[attribute].value[0]
    if base is not None and base in base_to_subset:
        # if fill the criteria, add subset to record
        r.subsets.add(base_to_subset[base])
        changed_recs.append(r)

# push changes!
s.update(changed_recs)

# In the code below, we do the reverse and de-populate the
# two subsets we just filled.
recs = tab.all_records(include_folders=True)

changed_recs = []
for r in recs:
    if {'Oxides', 'Iron-based'} & r.subsets:
        r.subsets.discard('Oxides')
        r.subsets.discard('Iron-based')
        changed_recs.append(r)
s.update(changed_recs)
